using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using MediaPortal.GUI.Library;

namespace MediaPortal.Plugins.MySlideShows
{
	/// <summary>
	/// Summary description for MySlideShowsSetup.
	/// </summary>
	public class MySlideShowsSetup : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.FolderBrowserDialog folderbDlg;
		private System.Windows.Forms.TextBox txtDatabaseFolder;
		private System.Windows.Forms.Button btnBrowse;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.RadioButton ckbPowerPoint2003;
		private System.Windows.Forms.RadioButton ckbPowerPointViewer;
		private System.Windows.Forms.TextBox txtPPTViewerDir;
		private System.Windows.Forms.Button btnBrowse2;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label lblPPTViewer;
		private System.Windows.Forms.ListView listView1;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtShareName;
		private System.Windows.Forms.Button btnAddShare;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem mnuRename;
		private System.Windows.Forms.MenuItem mnuRemove;
		private System.Windows.Forms.MenuItem mnuFolder;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.RichTextBox richTextBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MySlideShowsSetup()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnOK = new System.Windows.Forms.Button();
			this.folderbDlg = new System.Windows.Forms.FolderBrowserDialog();
			this.txtDatabaseFolder = new System.Windows.Forms.TextBox();
			this.btnBrowse = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.ckbPowerPointViewer = new System.Windows.Forms.RadioButton();
			this.ckbPowerPoint2003 = new System.Windows.Forms.RadioButton();
			this.txtPPTViewerDir = new System.Windows.Forms.TextBox();
			this.btnBrowse2 = new System.Windows.Forms.Button();
			this.lblPPTViewer = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.listView1 = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.mnuRename = new System.Windows.Forms.MenuItem();
			this.mnuFolder = new System.Windows.Forms.MenuItem();
			this.mnuRemove = new System.Windows.Forms.MenuItem();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.btnAddShare = new System.Windows.Forms.Button();
			this.txtShareName = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.richTextBox1 = new System.Windows.Forms.RichTextBox();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnOK
			// 
			this.btnOK.Location = new System.Drawing.Point(504, 344);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(64, 32);
			this.btnOK.TabIndex = 0;
			this.btnOK.Text = "Save";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// txtDatabaseFolder
			// 
			this.txtDatabaseFolder.Location = new System.Drawing.Point(8, 64);
			this.txtDatabaseFolder.Name = "txtDatabaseFolder";
			this.txtDatabaseFolder.Size = new System.Drawing.Size(256, 20);
			this.txtDatabaseFolder.TabIndex = 1;
			this.txtDatabaseFolder.Text = "";
			// 
			// btnBrowse
			// 
			this.btnBrowse.Location = new System.Drawing.Point(288, 64);
			this.btnBrowse.Name = "btnBrowse";
			this.btnBrowse.TabIndex = 2;
			this.btnBrowse.Text = "Browse...";
			this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.ckbPowerPointViewer);
			this.groupBox1.Controls.Add(this.ckbPowerPoint2003);
			this.groupBox1.Location = new System.Drawing.Point(16, 16);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(376, 80);
			this.groupBox1.TabIndex = 3;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Slideshow Viewer";
			// 
			// ckbPowerPointViewer
			// 
			this.ckbPowerPointViewer.Location = new System.Drawing.Point(16, 48);
			this.ckbPowerPointViewer.Name = "ckbPowerPointViewer";
			this.ckbPowerPointViewer.Size = new System.Drawing.Size(224, 24);
			this.ckbPowerPointViewer.TabIndex = 1;
			this.ckbPowerPointViewer.Text = "PowerPoint Viewer 2003";
			this.ckbPowerPointViewer.CheckedChanged += new System.EventHandler(this.ckbPowerPointViewer_CheckedChanged);
			// 
			// ckbPowerPoint2003
			// 
			this.ckbPowerPoint2003.Checked = true;
			this.ckbPowerPoint2003.Location = new System.Drawing.Point(16, 24);
			this.ckbPowerPoint2003.Name = "ckbPowerPoint2003";
			this.ckbPowerPoint2003.Size = new System.Drawing.Size(224, 24);
			this.ckbPowerPoint2003.TabIndex = 0;
			this.ckbPowerPoint2003.TabStop = true;
			this.ckbPowerPoint2003.Text = "PowerPoint 2003 (default)";
			// 
			// txtPPTViewerDir
			// 
			this.txtPPTViewerDir.Location = new System.Drawing.Point(16, 120);
			this.txtPPTViewerDir.Name = "txtPPTViewerDir";
			this.txtPPTViewerDir.Size = new System.Drawing.Size(264, 20);
			this.txtPPTViewerDir.TabIndex = 4;
			this.txtPPTViewerDir.Text = "";
			// 
			// btnBrowse2
			// 
			this.btnBrowse2.Location = new System.Drawing.Point(304, 120);
			this.btnBrowse2.Name = "btnBrowse2";
			this.btnBrowse2.TabIndex = 5;
			this.btnBrowse2.Text = "Browse...";
			this.btnBrowse2.Click += new System.EventHandler(this.btnBrowse2_Click);
			// 
			// lblPPTViewer
			// 
			this.lblPPTViewer.Location = new System.Drawing.Point(16, 104);
			this.lblPPTViewer.Name = "lblPPTViewer";
			this.lblPPTViewer.Size = new System.Drawing.Size(336, 16);
			this.lblPPTViewer.TabIndex = 6;
			this.lblPPTViewer.Text = "Directory where PowerPoint Viewer 2003 is installed:";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 40);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(232, 23);
			this.label2.TabIndex = 7;
			this.label2.Text = "Directory with your slideshows:";
			// 
			// listView1
			// 
			this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																																								this.columnHeader1,
																																								this.columnHeader2});
			this.listView1.ContextMenu = this.contextMenu1;
			this.listView1.LabelEdit = true;
			this.listView1.Location = new System.Drawing.Point(16, 280);
			this.listView1.MultiSelect = false;
			this.listView1.Name = "listView1";
			this.listView1.Size = new System.Drawing.Size(376, 128);
			this.listView1.TabIndex = 8;
			this.listView1.View = System.Windows.Forms.View.Details;
			this.listView1.DoubleClick += new System.EventHandler(this.listView1_DoubleClick);
			this.listView1.KeyUp += new System.Windows.Forms.KeyEventHandler(this.listView1_KeyUp);
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Name";
			this.columnHeader1.Width = 99;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "Folder";
			this.columnHeader2.Width = 273;
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																								 this.mnuRename,
																																								 this.mnuFolder,
																																								 this.mnuRemove});
			// 
			// mnuRename
			// 
			this.mnuRename.Index = 0;
			this.mnuRename.Text = "Re&name";
			this.mnuRename.Click += new System.EventHandler(this.mnuRename_Click);
			// 
			// mnuFolder
			// 
			this.mnuFolder.Index = 1;
			this.mnuFolder.Text = "&Change folder";
			this.mnuFolder.Click += new System.EventHandler(this.mnuFolder_Click);
			// 
			// mnuRemove
			// 
			this.mnuRemove.Index = 2;
			this.mnuRemove.Text = "&Remove";
			this.mnuRemove.Click += new System.EventHandler(this.mnuRemove_Click);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.btnAddShare);
			this.groupBox2.Controls.Add(this.txtShareName);
			this.groupBox2.Controls.Add(this.label1);
			this.groupBox2.Controls.Add(this.label2);
			this.groupBox2.Controls.Add(this.txtDatabaseFolder);
			this.groupBox2.Controls.Add(this.btnBrowse);
			this.groupBox2.Location = new System.Drawing.Point(16, 152);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(376, 120);
			this.groupBox2.TabIndex = 9;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Add Share";
			// 
			// btnAddShare
			// 
			this.btnAddShare.Location = new System.Drawing.Point(168, 88);
			this.btnAddShare.Name = "btnAddShare";
			this.btnAddShare.Size = new System.Drawing.Size(56, 24);
			this.btnAddShare.TabIndex = 10;
			this.btnAddShare.Text = "Add";
			this.btnAddShare.Click += new System.EventHandler(this.btnAddShare_Click);
			// 
			// txtShareName
			// 
			this.txtShareName.Location = new System.Drawing.Point(64, 16);
			this.txtShareName.Name = "txtShareName";
			this.txtShareName.Size = new System.Drawing.Size(200, 20);
			this.txtShareName.TabIndex = 9;
			this.txtShareName.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.TabIndex = 8;
			this.label1.Text = "Name:";
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(424, 24);
			this.label3.Name = "label3";
			this.label3.TabIndex = 10;
			this.label3.Text = "Help";
			// 
			// richTextBox1
			// 
			this.richTextBox1.BackColor = System.Drawing.SystemColors.Control;
			this.richTextBox1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.richTextBox1.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.richTextBox1.Location = new System.Drawing.Point(424, 56);
			this.richTextBox1.Name = "richTextBox1";
			this.richTextBox1.ReadOnly = true;
			this.richTextBox1.Size = new System.Drawing.Size(256, 256);
			this.richTextBox1.TabIndex = 11;
			this.richTextBox1.Text = @"Basic setup:

1) Choose your Slideshow Viewer. Note that sometimes Powerpoint Viewer 2003 can be a bit faster

2) If you chose Powerpoint Viewer 2003, select the directory where it is installed. Default should be ok.

3) Add some shares to define where your presentations are located. 

Notes:

* Rightclicking on an item in the list allows you to edit items.
* Doubleclicking on an item will prompt you for a new folder for that item.";
			// 
			// MySlideShowsSetup
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(688, 422);
			this.ControlBox = false;
			this.Controls.Add(this.richTextBox1);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.listView1);
			this.Controls.Add(this.lblPPTViewer);
			this.Controls.Add(this.btnBrowse2);
			this.Controls.Add(this.txtPPTViewerDir);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.btnOK);
			this.Name = "MySlideShowsSetup";
			this.Text = "MySlideshows Setup";
			this.Load += new System.EventHandler(this.MySlideShowsSetup_Load);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			string names = "";
			string folders = "";
			using (MediaPortal.Profile.Xml   xmlWriter=new MediaPortal.Profile.Xml("MediaPortal.xml"))
			{
				for (int i=0; i<listView1.Items.Count; i++)
				{
					ListViewItem it = listView1.Items[i];
					names = names + it.SubItems[0].Text + "|";
					folders = folders + it.SubItems[1].Text + "|";
				}
				if(listView1.Items.Count > 0)
				{
					names = names.Remove(names.Length - 1,1);
					folders = folders.Remove(folders.Length - 1,1);
				}
				xmlWriter.SetValue("MySlideshows","sharenames",names);
				xmlWriter.SetValue("MySlideshows","sharefolders",folders);
				xmlWriter.SetValue("MySlideshows","PowerPointViewerDirectory",txtPPTViewerDir.Text);
				if (ckbPowerPoint2003.Checked)
					xmlWriter.SetValue("MySlideshows","ViewSystem","Office2003");
				else
					xmlWriter.SetValue("MySlideshows","ViewSystem","PowerPointViewer");
			}
			this.Close();
		}

		private void btnBrowse_Click(object sender, System.EventArgs e)
		{
			folderbDlg.SelectedPath = txtDatabaseFolder.Text;
			if (folderbDlg.ShowDialog() ==  DialogResult.OK)
			{
				txtDatabaseFolder.Text = folderbDlg.SelectedPath;
			}
		}

		private void MySlideShowsSetup_Load(object sender, System.EventArgs e)
		{
			using(MediaPortal.Profile.Xml xmlreader = new MediaPortal.Profile.Xml("MediaPortal.xml"))
			{
				txtPPTViewerDir.Text = xmlreader.GetValueAsString("MySlideshows","PowerPointViewerDirectory","");
				char[] sep = new char[]{'|'};
				string[] sNames = xmlreader.GetValueAsString("MySlideshows","sharenames","").Split(sep);
				string[] sFolders = xmlreader.GetValueAsString("MySlideshows","sharefolders","").Split(sep);
				for(int i = 0; i<sNames.Length;i++)
				{
					string[] param = new string[2];
					param[0] = sNames[i];
					param[1] = sFolders[i];
					ListViewItem it = new ListViewItem(param);
					listView1.Items.Add(it);
				}
				string str = xmlreader.GetValueAsString("MySlideshows","ViewSystem","Office2003");
				if (str == "Office2003")
					ckbPowerPoint2003.Checked = true;
				if (str == "PowerPointViewer")
					ckbPowerPointViewer.Checked = true;
			}
		}

		private void ckbPowerPointViewer_CheckedChanged(object sender, System.EventArgs e)
		{
			bool ckd = ckbPowerPointViewer.Checked;
			txtPPTViewerDir.Enabled = ckd;
			btnBrowse2.Enabled = ckd;
			lblPPTViewer.Enabled = ckd;
		}

		private void btnBrowse2_Click(object sender, System.EventArgs e)
		{
			folderbDlg.SelectedPath = txtPPTViewerDir.Text;
			if (folderbDlg.ShowDialog() ==  DialogResult.OK)
			{
				txtPPTViewerDir.Text = folderbDlg.SelectedPath;
			}
		}

		private void btnAddShare_Click(object sender, System.EventArgs e)
		{
			if(System.IO.Directory.Exists(txtDatabaseFolder.Text) == true)
			{
				string[] param = new string[2];
				param[0] = txtShareName.Text;
				param[1] = txtDatabaseFolder.Text;
				ListViewItem it = new ListViewItem(param);
				listView1.Items.Add(it);
			}
			else
			{
				MessageBox.Show("Invalid directory", "Error",MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void listView1_DoubleClick(object sender, System.EventArgs e)
		{
			if (listView1.SelectedItems[0].Selected)
			{
				folderbDlg.SelectedPath = listView1.SelectedItems[0].SubItems[1].Text;
				if (folderbDlg.ShowDialog() ==  DialogResult.OK)
				{
					listView1.SelectedItems[0].SubItems[1].Text = folderbDlg.SelectedPath;
				}
			}
		}

		private void mnuRename_Click(object sender, System.EventArgs e)
		{
			if(listView1.SelectedItems.Count > 0)
				listView1.SelectedItems[0].BeginEdit();
		}

		private void mnuRemove_Click(object sender, System.EventArgs e)
		{
			if(listView1.SelectedItems.Count == 0)
				return;
			if(MessageBox.Show("Are you sure you want to remove \"" + listView1.SelectedItems[0].Text + "\"?",
				"Remove",MessageBoxButtons.YesNo) == DialogResult.Yes)
			{
				listView1.SelectedItems[0].Remove();
			}
		}

		private void mnuFolder_Click(object sender, System.EventArgs e)
		{
			if(listView1.SelectedItems.Count == 0)
				return;			
			folderbDlg.SelectedPath = listView1.SelectedItems[0].SubItems[1].Text;
			if (folderbDlg.ShowDialog() ==  DialogResult.OK)
			{
				listView1.SelectedItems[0].SubItems[1].Text = folderbDlg.SelectedPath;
			}
		}

		private void listView1_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			mnuRemove_Click(new object(), new EventArgs());
		}
	}
}
